
  var alphabet = "abcdefghijklmnopqrstuvwxyz";
  var alphaLen = alphabet.length;

/* Werte und Algorithmen fr Csar-Chiffre */

  function proof_cesar_key1() {
    var key = document.cesar.key1.value;

    if (isNaN(key) || key < 0) {
       alert("Der Schlsselwert muss eine\npositive, ganze Zahl sein.\n(Wertebreich: 0 bis 25)");
       return false;
    }
    else
       document.cesar.keyA.value = alphabet.charAt(key%alphaLen).toUpperCase();
    return true;
  }

  function proof_cesar_keyA() {
    var key = document.cesar.keyA.value;

    if (isNaN(key) && alphabet.indexOf(key) >= 0) {
       document.cesar.key1.value = alphabet.indexOf(key);
       document.cesar.keyA.value = key.toUpperCase();
    } else {
       alert("Der Schlsselwert muss ein\neinzelner Buchstabe sein.\n(Wertebreich: a bis z)");
       return false;
    }
    return true;
  }

  function encrypt_cesar(key) {
    var i, n=0;
    var chiffre = "";
    var text    = document.cesar.klartext.value.toLowerCase();
    var len     = text.length;

    if (proof_cesar_key1()) {
       key = key % alphaLen;
       for (i=0; i<=len-1; i++) {
           n = alphabet.indexOf(text.charAt(i));
           if (n >= 0)
              chiffre = chiffre + alphabet.charAt((n+key)%alphaLen);
           else chiffre = chiffre + text.charAt(i);
       }
       document.cesar.geheimtext.value = chiffre.toUpperCase();
    }
  }

  function decrypt_cesar(key) {
    var i, n=0;
    var chiffre = "";
    var text    = document.cesar.geheimtext.value.toLowerCase();
    var len     = text.length;

    if (proof_cesar_key1()) {
       key = key % alphaLen;
       for (i=0; i<=len-1; i++) {
           n = alphabet.indexOf(text.charAt(i));
           if (n >= 0)
              chiffre = chiffre + alphabet.charAt(((alphaLen)+(n-key))%alphaLen);
          else chiffre = chiffre + text.charAt(i);
       }
       document.cesar.klartext.value = chiffre.toLowerCase();
    }
  }

/* Werte und Algorithmen fr Vigenre-Chiffre */

  function proof_vigen_key(key) {
    var i = 0;

    if (key != "") {
       key = key.toLowerCase();
       for (i=0; i<key.length; i++)
           if (alphabet.indexOf(key.charAt(i)) < 0) {
              alert("Das Schlsselwort >" + key + "< darf nur\naus den Buchstaben a bis z bestehen,\nSonderzeichen oder Umlaute gehen nicht.");
              return false;
           }
       return true;
    } else {
       alert("Ohne Schlssel keine Verschlsselung.");
       return false;
    }
  }

  function encrypt_vigen(key, text) {
    var i, j = 0;
    var hlp  = 0;
    var chiffre = "";

    text = text.toLowerCase();
    key  = key.toLowerCase();
    if (proof_vigen_key(key)) {
       for (i=0; i < text.length; i++) {
           hlp = alphabet.indexOf(text.charAt(i));
           if (hlp >= 0) {
              chiffre = chiffre + alphabet.charAt((hlp+alphabet.indexOf(key.charAt(j)))%alphaLen);
              j = (j+1) % key.length;
           } else
              chiffre = chiffre + text.charAt(i);
       }
    }
    document.vigen.geheimtext.value = chiffre.toUpperCase();
  }

  function decrypt_vigen(key, chiffre) {
    var i, j = 0;
    var hlp  = 0;
    var text = "";

    chiffre = chiffre.toLowerCase();
    key     = key.toLowerCase();
    if (proof_vigen_key(key)) {
       for (i=0; i < chiffre.length; i++) {
           hlp = alphabet.indexOf(chiffre.charAt(i));
           if (hlp >= 0) {
              text = text + alphabet.charAt((alphaLen+(hlp-alphabet.indexOf(key.charAt(j))))%alphaLen);
              j = (j+1) % key.length;
           } else
              text = text + chiffre.charAt(i);
       }
       document.vigen.klartext.value = text.toLowerCase();
    }
  }

  function count_chars() {
    var anz_char = new Array (alphaLen);
    var text     = document.counting.klartext.value.toLowerCase();
    var i = 0;

    for (i=0; i < alphaLen; i++)
        anz_char[i] = 0;

    for (i=0; i < text.length; i++) {
        hlp = alphabet.indexOf(text.charAt(i));
        if (hlp >= 0)
           anz_char[hlp] = anz_char[hlp] + 1;
    }

    document.counting.geheimtext.value = "";
    for (i=0; i < alphaLen; i++) {
        document.counting.geheimtext.value = document.counting.geheimtext.value + " " +  alphabet.charAt(i);
        if (anz_char[i] < 100)
           if (anz_char[i] < 10)
              document.counting.geheimtext.value = document.counting.geheimtext.value + " =  ";
           else
              document.counting.geheimtext.value = document.counting.geheimtext.value + " = ";
        else
           document.counting.geheimtext.value = document.counting.geheimtext.value + " =";
        document.counting.geheimtext.value = document.counting.geheimtext.value + anz_char[i]+ ", ";
        if (i%2 == 1)
           document.counting.geheimtext.value = document.counting.geheimtext.value +"\n"
    }
  }