/* Funktionen fr die selbsterstellten Algorithmen. */
 var Modulus = 65536;

 function nextRandom(X, modulus) {
 /* Methode: Lineare Kongruenz =>  X[i] = (a * X[i-1] + b) mod m    */
 /* Mit den gewhlten Parametern ergibt sich eine maximale Periode, */
 /* welches unabhngig von gewhlten Startwert ist(?).              */
    var y = (17*X + 1) % modulus;
    return y;
 }/* nextRandom */

 function getBlockLength(m) {
    var i = 0;
    while(m > 0) {
       i++;
       m = m>>8;
    }
    return i-1;
 }/* getBlockLength */

 function getKey(key) {
    if (isNaN(key)) {
       key = key + key;
       key = (key.charCodeAt(0)<<8) + key.charCodeAt(1);
    } else {
       key = parseInt(key);
       if (isNaN(key))
          key = 3333;
       else if (key < 0)
               key = key * -1;
    }
    key = key + 1;
    while (key < Math.floor(Modulus/3))
          key = key * 3;
    return (key%Modulus);
 }/* getKey */


/* Funktionen fr HGC1 */
 function crypt_HGC1(X, EinText) {
    var rndm = 0;
    var AusText = "";
    Modulus = 65536;

    var i = 0;
    while (i < EinText.length) {
       if (i%2 == 0) {
          X = nextRandom(X, Modulus);
          rndm = X & 255;
       } else
          rndm = (X>>8) & 255;
       if (EinText.charCodeAt(i) == rndm)
          /* Achtung: Sonderbehandlung erforderlich bei Stringendezeichen */
          AusText = AusText + String.fromCharCode(EinText.charCodeAt(i));
       else
          AusText = AusText + String.fromCharCode(EinText.charCodeAt(i)^rndm);
        i++;
    }
    return AusText;
 }/* crypt_HGC1 */

 function encrypt_1(key, text) {
    document.FirstTry.chiffriert.value = escape(crypt_HGC1(getKey(key), text));
 }/* encrypt_1 */

 function decrypt_1(key, chiffre) {
    document.FirstTry.dechiffriert.value = crypt_HGC1(getKey(key), unescape(chiffre));
 }/* decrypt_1 */


/* Funktionen fr HGC2 */
 function crypt_HGC2(X, EinText, encrypt) {
    var AusText = "";
    var Temp    = 0;
    Modulus = 65536;
    var BlkLen = getBlockLength(Modulus);

    while (EinText.length % BlkLen != 0)
       EinText = EinText + " ";

    var i = 0;
    while (i < EinText.length) {
       var Block = 0;

       Block = (EinText.charCodeAt(i++)<<8) + EinText.charCodeAt(i++);

       X = nextRandom(X, Modulus);
       Temp = Block^X;
       if (encrypt) X = Temp;
       else X = Block;

       AusText = AusText + String.fromCharCode((Temp>>8)&255);
       AusText = AusText + String.fromCharCode(Temp&255);
       if (((Temp>>8)&255==0) || (Temp&255==0)) alert(i);
    }
    return AusText;
 }/* crypt_HGC2 */

 function encrypt_2(key, text) {
    document.SecondTry.chiffriert.value = escape(crypt_HGC2(getKey(key), text, 1));
 }/* encrypt_2 */

 function decrypt_2(key, chiffre) {
    document.SecondTry.dechiffriert.value = crypt_HGC2(getKey(key), unescape(chiffre), 0);
 }/* decrypt_2 */




/* Funktionen fr HGC3 */

 function crypt_HGC3(key, EinText, encrypt) {
    var AusText = "";
    var Sign, i, X = 255;
    Modulus = 65536;

    for (i=0; i < key.length; i++)
        X = (X * key.charCodeAt(i)) % Modulus;

    i = 0;
    while (i < EinText.length) {
       X = nextRandom(X, Modulus);

       Sign = EinText.charCodeAt(i) ^ ((X>>8)&255);
       Sign = Sign ^ key.charCodeAt(i%key.length);

       if (encrypt) X = X ^ Sign;
       else         X = X ^ EinText.charCodeAt(i);

       AusText = AusText + String.fromCharCode(Sign);
       i++;
    }
    return AusText;
 }/* crypt_HGC3 */

 function encrypt_3(key, text) {
    document.ThirdTry.chiffriert.value = escape(crypt_HGC3(key, text, 1));
    // document.ThirdTry.chiffriert.value = crypt_HGC3(key, text, 1);
 }/* encrypt_3 */

 function decrypt_3(key, chiffre) {
    document.ThirdTry.dechiffriert.value = crypt_HGC3(key, unescape(chiffre), 0);
    // document.ThirdTry.dechiffriert.value = crypt_HGC3(key, chiffre, 0);
 }/* decrypt_3 */